﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.GpstrackingServer.Geteways.GatewaySdk;

namespace ThinkGeo.GpstrackingServer.Geteways.GatewaySample
{
    public partial class MainForm : Form
    {

        // Here is your Api key
        private const string ApiKey = "<Your Api Key>";
        // Here is your gateway web service
        private const string GatewayWebServiceUri = "https://gpsgateway.thinkgeo.com";
     
        private GatewayManager mGatewayManager;

        public MainForm()
        {
            InitializeComponent();
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            if (ValidateInput())
            {
                mGatewayManager = new GatewayManager();
                mGatewayManager.ApiKey = ApiKey;
                mGatewayManager.GatewayUri = new Uri(GatewayWebServiceUri);

                DeviceMessage deviceMessage = new DeviceMessage();
                deviceMessage.DeviceId = txtDeviceID.Text;
                deviceMessage.Longitude = decimal.Parse(txtLongitude.Text);
                deviceMessage.Latitude = decimal.Parse(txtLatitude.Text);
                deviceMessage.Heading = int.Parse(txtHeading.Text);
                deviceMessage.GpsAccuracyInMeters = int.Parse(txtGpsAccuracy.Text);
                deviceMessage.SpeedInKph = int.Parse(txtSpeed.Text);
                deviceMessage.UtcDateTime = DateTime.Parse(txtUtcDateTime.Text);
                deviceMessage.AltitudeInMeters = int.Parse(txtAltitude.Text);
                deviceMessage.RawDebugMessage = txtRawDebugMessage.Text;

                deviceMessage.Alerts.Add(txtAlert.Text);
                deviceMessage.CustomData.Add(new CustomData(txtCustomDataName.Text, txtCustomDataValue.Text, MimeType.Text));
                PostResult result = mGatewayManager.PostDeviceMessage(deviceMessage);
                if (result.Code == ResultCode.Error)
                {
                    MessageBox.Show(result.ErrorMessage);
                }
                else
                {
                    MessageBox.Show("The message has been posted to the gateway.");
                }
            }
        }

        private bool ValidateInput()
        {
            if (txtDeviceID.Text.Trim() == "")
            {
                MessageBox.Show("Please enter your Device ID(IMEI).\nYou can get a valid Device ID(IMEI) by logging into your GPS Tracking Server account.");
                return false;
            }
            return true;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            txtUtcDateTime.Text = DateTime.UtcNow.ToString();
        }
    }
}
